Release notes
=============

master
------

Incompatibilities:

 - Update remote repo variables. (#1358)

Bug fixes:

 - Fix various issues with `diff.noprefix` and `--no-prefix`.
 - Fix `Ctrl-C` behavior within the Readline prompt. (#1342)
 - Fix message upon edit from diffstat without patch.
 - Fix missing dates in the refs view.
 - Don't report an error when diff-highlight is killed intentionally.
 - Fix parsing of reflog designator in timestamp format.

Improvements:

 - Open the blob corresponding to the diff line. (#1334)
 - Keep cursor position in the main view when toggling
   file-filter and rev-filter.
 - Make errors visible in views showing Git output. (#1346)
 - Allow different colors for all references types.
 - Enable search in sections titles. (#1043)
 - Show committer date by default in the date column. (#294)

tig-2.5.10
----------

Bug fixes:

 - Fix `stat-*` coloring file names in `tig status` instead of just
   markers (regression in 2.5.9). (#1326)
 - Fix keybinding with +[cmd] not triggering view refreshing. (#1324)
 - Fix reopening the blame view from the main view.
 - Fix editing when stdin is redirected. (#1330)
 - Fix compilation warnings with ncurses 6.5.
 - Make `Ctrl-C` to kill only the command running in the foreground. (#1331)

tig-2.5.9
---------

Improvements:

 - Update utf8proc to v2.9.0, supporting Unicode 15.1.
 - Also use lightweight tags in the Refs line of the diff view. (#1235)
 - Support %(text) in all views with a text column. (#1275)
 - Use HTTPS for GitHub clone URLs. (#1310)
 - Move default log view options to tigrc.
 - Allow to go to stage view without Enter. (#1284)
 - Add new "prefetch" reference type for refs created by `git maintenance`
   (hidden in default config). (#1318)
 - Show the selected commit in the blame view title window.
 - Improve the blob view experience.
 - Clear keybinding from all keymaps (unbind) with `bind generic <key> none`.

Bug fixes:

 - Fix "dangling pointer" warning. (#1268)
 - Don't use array size in function arguments. (#1269)
 - Fix rpmbuild -ta. (#1276)
 - Initialise struct timezone. (#1291)
 - Fix NULL dereference at startup. (#1293)
 - Enforce a blank before view scroll percentage.
 - Fix refresh-mode periodic not updating branch labels. (#1270)
 - Fix display non-ascii character. (#1299)
 - Fix readline echo when stdin is redirected. (#1229)
 - Fix tig blame --reverse. (#1300)
 - Fix status view lockup.
 - Fix untracked changes and chunk staging behaviour in plain stage view.
 - Reset state variables when selecting a commit with no reference.
 - Fix parsing of `git ls-tree` for submodules. (#1282)

tig-2.5.8
---------

Improvements:

 - Update utf8proc to v2.8.0, supporting Unicode 15.
 - Support editing from the pager and the log (-p) views. (#1243)
 - Adjust build for native Apple Silicon.
 - Autoscroll the pager view while loading. (#1223)
 - Automatically show next diff in the status view. (#413, #469)
 - Replace `Unknown` author with `Not Committed Yet`.
 - Allow use of regular expressions for coloring. (#1249)
 - Add support for option word-diff-regex. (#1252)
 - Include original blob name in temporary filename. (#1254)

Bug fixes:

 - Use %(file_old) for old filename in the blame view. (#1226)
 - Correctly report which version of libncurses was linked. (#1240, #1241)
 - Fix stage view closing when holding the ] key. (#1245)
 - Make tests work from a path with symlinks.
 - Fix encoding of very long lines. (#1227)
 - Fix diffstat color for tig log -p.
 - Clean IO before closing a view or quitting.

tig-2.5.7
---------

Bug fixes:

 - Fix running tests as root. (#1224)
 - Fix parsing of status.showUntrackedFiles. (#1219)
 - Avoid incorrect history path when $XDG_DATA_HOME is valid. (#1215, #1217)

tig-2.5.6
---------

Bug fixes:

 - Fix `:goto <tag>`. (#1178)
 - Fix typo in ui.c.
 - Revert terminal hacks and workarounds. (#748, #943, #1180, #1182)
 - Fix opening of an ambiguous ref in refs view.
 - Fix search when view is loading.
 - Use the full width for diffstat in the stage view.
 - Improve escaping of variables in external commands.
 - Fix cursor behaviour during staging. (#842, #1028)
 - Fix navigation in split tree view.
 - Enable textconv in the stage view.
 - Enable textconv in the blame view and fix blame -L. (#978, #1189)
 - Update lineno for untracked files. (#1192)
 - Fix alignment of transliterated text. (#1195)
 - Fix word diff in the stage, stash and blame views. (#1207)
 - Fix reading the value of status.showUntrackedFiles. (#1211)
 - Honor commit_title:no in view settings.
 - Fix segfault with PCRE.

tig-2.5.5
---------

Improvements:

 - Make word-diff a toggleable option. (#1119, #1125)
 - Add Linux installation instructions. (#1121, #1126)
 - Allow :back to work across separate blame views. (#1123, #1127)
 - Add auto-refresh to log view. (#1128)
 - Expose `%(file_old)`, useful for deleted and renamed files. (#1132)
 - Enable jumping back in main view. (#628, #1138)
 - Add PCRE (Perl Compatible Regular Expressions) support. (#1137, #1143)
 - Pass command line args through to diff-files in status view. (#1152, #1155)
 - Remove quotes from TIG_LS_REMOTE to allow inline shell commands. (#1160, #1161)
 - Avoid pushing identical history state in main view.
 - Replace useless strncpy to avoid compilation warning with GCC 8.
 - Update utf8proc to v2.7.0.
 - Update distclean rule to preserve tarball contents. (#1167, #1169)
 - Add reference types stash and other. (#1160, #1172)
 - Auto refresh view upon option change.
 - Allow to toggle revision filtering. (#1173)

Bug fixes:

 - Fix null dereferences on unset format strings. (#1136, #1159)
 - Fix invalid read in log_read. (#1128)
 - Restore support for tig log --graph. (#1128)
 - Further fix to fullscreen navigation.
 - Fix blame when opened from an initial diff view. (#1135)
 - Fix stash view when using tig --all or tig revs. (#1146, #1147)
 - Avoiding null pointer dereference. (#1096)
 - Fix navigation between chunks after splitting chunk. (#1101, #1162)
 - Fix status line when toggling general options. (#1163, #1164)
 - Honor reference-format = hide:tag in diff view. (#1168, #1170)
 - Fix crash on :toggle file-args.

tig-2.5.4
---------

Improvements:

 - Add FreeBSD installation instructions. (#1093)
 - Add TIG_EDITOR environment variable to configure editor. (#889, #1098)
 - Enable mailmap by default to match git log's behaviour. (#1104, #1105)
 - Enable tilde expansion for diff-highlight. (#1107)

Bug fixes:

 - Escape variables with %% in external commands. (#1091, #1095)
 - Fix parsing of -L argument. (#1100)
 - Bugfix: smart-case does not work when search term contains a space. (#1108)
 - Use ncursesw by default on Linux. (#920)
 - Replace obsolete macro `AC_CONFIG_HEADER' in configure.ac.

tig-2.5.3
---------

Bug fixes:

 - Fix autoconf checking for readline. (#1072)
 - Fix segfault when saving a view with no column.
 - Reset view->parent when main view is promoted.
 - Fix segfault when pressing Enter in a child main view.
 - Restore lazy navigation.
 - Format time_t values portably and fix other values too. (#1084, #1085)
 - Fix loop when wrapping line with ISO-8859-1 character. (#1087, #1088)

tig-2.5.2
---------

Incompatibilities:

 - Change directory from the next argument, from now use `tig -C /path/to/repo`. (#1079)

Improvements:

 - Jump from blame to commit. (#355)
 - Start blame of an uncommitted deleted line from HEAD so the line's origin can be traced. (#1008, #1009)
 - Add line-graphics = auto. (#834, #1019)
 - Allow maxwidth to be expressed in % of the view width. (#1021)
 - Pass stash args through. (#1022, #1030)
 - Make build work on IBM i. (#1051, #1052)
 - Restore fullscreen navigation. (#1053)
 - Update utf8proc to v2.6.1.
 - Add some range so control chars ^^ and ^_ are also supported. (#1041, #1058)
 - Disable ncurses extended key values so that esc-codes can be used. (#1046, #1049)
 - Use id column for commit id only. (#1025, #1056)
 - Some minor updates for scrolling and for a double-click in diff. (#1060)
 - Add scroll-half-page-up and scroll-half-page-down actions. (#531, #1075)
 - Allow to generate a compilation database. (#1064)
 - New command stage-update-part.
 - The line number before a diff was applied is exposed as `%(lineno_old)`. (#1081)

Bug fixes:

 - Fix wrapping of lines with multibyte characters. (#988)
 - Improve highlighting of search with $ regex. (#1000)
 - Update tracking branch when refreshing status view. (#1015)
 - Fix vertical lines in Putty with UTF-8 graphics. (#981, #983)
 - Fix parsing of three-way chunk headers with extra dashes.
 - Update tracking branch when refreshing status view. (#1015, #1020)
 - Handle filename with space in diff view. (#1035)
 - The stash view requires a working tree.
 - Replace useless strncpy to avoid compilation warning. (#1036)
 - Zsh completion fixes. (#940, #1047)
 - Handle undefined __git_complete. (#1011, #1055)
 - Fix help messages for half-page and page up. (#1054)
 - Let `-S`, `-G` and `--grep=` pattern override readline history.
 - Fix bash completion issue with worktrees (#1018).
 - Fix parsing of commit line from `git log --left-right` output in pager view.
 - Fix %(lineno) computation for hunk postimages that span only one line. (#1062)
 - Align relative-compact dates to the right. (#1067)
 - Fix empty split diff view when navigating quickly in the stash view.
 - Avoid depending on wcwidth in test by removing Variation Selector. (#1065)
 - Open the blob view with the cursor correctly positioned.
 - Update %(text) when navigating diff contents. (#1082)

tig-2.5.1
---------

Improvements:

 - bash/zsh completion: reimplement and decrease runtime by factor 1863. (#795)
 - Add binding to reflog view to toggle reference display.
 - Fail if tig is given an invalid or ambiguous ref. (#980)
 - Make tig process-group leader an option. (#986, #951)
 - Handle GIT_WORK_TREE environment variable.
 - The blame view requires a working tree.
 - Fix use of deprecated vwprintw() function.
 - Update utf8proc to v2.5.0.
 - Add --word-diff=plain colorizing support. (#221)

Bug fixes:

 - Fix segmentation fault. (#971)
 - Fix cursor position after "Move to parent" in blame view. (#973)
 - Fix crash on adding a line to a view. (#523)
 - Fix memory leak in diff unit.
 - Fix loop after refresh or change in refs/main split view. (#991)
 - Fix occasional crash on custom key bindings. (#1001)

tig-2.5.0
---------

Improvements:

 - Single file view enters blame mode on "b". (#804)
 - Show untracked files in the default view. (#762)
 - Disable graph if log.follow is enabled and there is only one pathspec. (#881)
 - Disable graph for author searches.
 - git_colors: interpret 'ul' as 'underline'.
 - Add refname variable. (#900)
 - Add -C option to specify the working directory. (#570)
 - Improve behaviour of auto and periodic refresh modes. (#389, #441, #482, #794, #888, #932)
 - Add support for repos created with git --work-tree. (#872)
 - Add diff-highlight to pager mode.
 - Show annotated commits in main view. (#819)
 - Introduce reflog view. (#538)
 - Add option to start with cursor on HEAD commit. (#755)
 - Support combined diffs with more than 2 parents.
 - Improve how a toggle option value is shown on the status line. (#879)
 - Add options to filter refs output. (#694)
 - Update utf8proc to v2.4.0. (#961)

Bug fixes:

 - Fix garbled cursor line with older ncurses versions.
 - Fix diff highlighting of removed lines starting with -- and added lines
   starting with ++. (#871, #875)
 - Fix loop when displaying search result if regex matches an empty string. (#866)
 - Add synchronous command description in tigrc.
 - Fix parsing of git rev-parse output. (#884)
 - Propagate --first-parent to diff arguments. (#861)
 - Use proper type for hash table size. (#858)
 - Fix incorrect cppcheck warning about realloc() use.
 - Don't shift signed int by 31 bits.
 - Fix Vim going background after running Tig outside of a git repository. (#906)
 - make-builtin-config: use "read -r". (#912)
 - Fix segfaults with readline 8.0. (#893)
 - Reset state before closing stage view automatically.
 - Don't use a child view as previous view.
 - Force reload of VIEW_FLEX_WIDTH views only when needed.
 - Combined diff uses @@@ as hunk marker.
 - Fix memory leak induced by 'tig grep'.
 - Fix memory leak in main view.
 - Exit gracefully if refs view was defined without ref column. (#897)
 - Fix pager view not moving up when child view is open.
 - make-builtin-config: Fix unportable sed usage in read_tigrc().
 - Properly detect combined diffs. (#942)

tig-2.4.1
---------

Bug fixes:

 - Add `CURSES_CFLAGS` to `CPPFLAGS`. (#856, Linuxbrew/homebrew-core#8440)

tig-2.4.0
---------

Improvements:

 - Add 'send-child-enter' option to control interaction with child views. (#791)
 - Update make config defaults for Cygwin to ncurses6. (#792)
 - Build against netbsd-curses. (#789)
 - Change the blame view to render more like `git blame`. (#812)
 - Improve worktree and submodule support. (#459, #781, #783)
 - Support running Tig via a Git alias. (#763)
 - Use ISO-8601 letters for short relative dates. (#759, #760)
 - Change date formatting to show time zones by default. (#428, #811)
 - Use utf8proc to handle Unicode characters. (#827)

Bug fixes:

 - Fix `file(1)` argument on Linux used for resolving encodings. (#788)
 - Fix underflow in the file search. (#800, #801)
 - Fix line numbers in grep view when scrolled. (#813)
 - Pass command line args through to the stage view. (#569, #823)
 - Fix resource leak. (#780)
 - Fix various compiler warnings and pointer arithmetic. (#799, #803)
 - Workaround potential null pointer dereferences. (#824)
 - Bind to single and double quotes by using the *<SingleQuote>* and
   *<DoubleQuote>* key mappings. (#821)
 - Make Tig the process-group leader and clean child processes. (#828, #837)
 - Fix sh compatibility in `contrib/tig-pick`. (#832)
 - Fix incorrect behaviour of up and down keys in diff view when opened from
   diff preview. (#802, #835)
 - Open the stage view when maximizing a split diff view of (un)staged changes.
   (#836)
 - Use fully qualified reference name for tags when conflicting with branch
   name. (#746, #787, #849)
 - Fix resize not working after entering command. (#845) (#846)
 - Use stack allocated memory to handle `TIG_LS_REMOTE`. (#839)
 - Fix deleted file mode line remains highlighted after hovering in diff or stage view. (#851)
 - Fix `TIG_LS_REMOTE` not working with git-ls-remote(1). (#853, #854)

tig-2.3.3
---------

Bug fixes:

 - Revert "Handle \n like \r (#758)". (GH #769)
 - Fix GH #164 by catching SIGHUP.
 - Change `refs_tags` type to `size_t`.

tig-2.3.2
---------

Bug fixes:

 - Fix busy loop detection to handle large repos. (GH #164)

tig-2.3.1
---------

Improvements:

 - Restore TTY attributes. (GH #725)
 - Handle `\n` like `\r`. (GH #758)

Bug fixes:

 - Add workaround that detects busy loops when Tig loses the TTY. This may
   happen if Tig does not receive the HUP signal (e.g. when started with
   `nohup`). (GH #164)
 - Fix compatibility with ncurses-5.4 which caused copy-pasting to not work
   in the prompt. (GH #767)
 - tig(1): document correct environment variable. (GH #752)

tig-2.3.0
---------

Incompatibilities:

 - The `width` setting on the `status`, `text` and `commit-title` columns was
   never applied and has been removed. (GH #617)

Improvements:

 - Improve load performance by throttling screen updates. (GH #622, #629)
 - Speed up graph rendering. (GH #638)
 - Enable scroll optimizations for Terminal.app and iTerm2. (GH #637)
 - Improve the test suite portability to not depend on GNU sed. (GH #609, #614)
 - Make build reproducible. (https://reproducible-builds.org/) (GH #613)
 - Enable binding to more symbolic keys and keys with control modifier:
   `F13`-`F19`, `ShiftLeft`, `ShiftRight`, `ShiftDel`, `ShiftHome`, `ShiftEnd`,
   `ShiftTab`, `Ctrl-C`, `Ctrl-V`, `Ctrl-S`, and `Ctrl-@`. (GH #314, #619, #642)
 - Persist readline history to `~/.tig_history` or `$XDG_DATA_HOME/tig/history`.
   Use `history-size` to control the number of entries to save. (GH #620, #713,
   #714, #718)
 - Preload last search from persistent history. (GH #630)
 - Add `view-close-no-quit` action, unbound by default. (GH #607)
 - Add `mouse-wheel-cursor` option (off by default) when set to true causes
   wheel actions to prefer moving the cursor instead of scrolling. (GH #608)
 - Add `truncation-delimiter` option, set to `~` by default. (GH #646)
 - Add `-q` parameter to `source` for "source-if-present". (GH #612)
 - Add `:echo` prompt command to display text in the status bar. (GH #626, #636)
 - Make `diff-highlight` colors configurable. (GH #625, #633)
 - Let Ctrl-C exit Y/N dialog, menu prompts and the file finder. (GH #632, #648)
 - Hide cursor unless at textual prompt. (GH #643)
 - Expand tilde ('~') in `:script` paths. (GH #674)
 - Show single-line output of external command in status bar. (GH #200, #557,
   #678)
 - Disable the graph when `--no-merges` is passed. (GH #687) 
 - Print backtraces on segfault in debug mode.
 - Ignore script lines starting with `#` (comment). (GH #705)
 - Complete `repo:*` variables when readline is enabled. (GH #702)
 - Incorporate XTerm's `wcwidth.c` to find Unicode widths. (GH #691)

Bug fixes:

 - Fix graph display issues. (GH #419, #638)
 - Fix and improve rendering of Unicode characters. (GH #330, #621, #644, #682)
 - Handle hyphenated directory names when listing content. (GH #602)
 - Do not jump to next match when cancelling the search prompt. (GH #627)
 - Fix clearing of the status line after `Ctrl-C`. (GH #623, #649)
 - Fix handling of width on line-number and trimmed width of 1. (GH #617)
 - Set cursor position when not updating prompt contents. (GH #647)
 - Erase status line at exit time for users without altscreen-capable terminals.
   (GH #589)
 - Fix unexpected keys when restoring from suspend (`Ctrl-Z`). (GH #232)
 - contrib/vim.tigrc: Also bind G in the main as a workaround for limitations of
   the `none` action. (GH #594, #599)
 - Only override `blame-options` when commands are given and fix parsing of
   `-C`. (GH #597)
 - Fix diff name discovery to better handle prefixes.
 - Interpret button5 as wheel-down. (GH #321, #606)
 - Fix `back` / `parent` in tree view. (GH #641)
 - Fix memory corruption in `concat_argv` and file finder. (GH #634, #655)
 - Fix reading from stdin for `tig show`.
 - Document problem of outdated system-wide `tigrc` files in Homebrew. (GH #598)
 - Repaint the display when toggling `line-graphics`. (GH #527)
 - Fix custom date formatting support longer strings. (GH #522)
 - Don't segfault on ":exec" irregular args. (GH #686)
 - Fix segfault when calling htab_empty. (GH #663, #745)

tig-2.2.2
---------

Upgrade instructions:

 - The `status-untracked-dirs` option was renamed to
   `status-show-untracked-dirs` to match the new `status-show-untracked-files`
   option.

Improvements:

 - Use `diff-options` when preparing the diff in the stage view to make the diff
   state configurable. (GH #545)
 - Add 'status-show-untracked-files' option mirroring Git's
   'status.showUntrackedFiles' to toggle display of untracked files.  in the
   status view. On by default. (GH #562)
 - Update `ax_with_curses.m4` and use `pkg-config` to detect. (GH #546)
 - Add `tig-pick` script for using Tig as a commit picker. (GH #575, #580)
 - Add "smart case" option ('set ignore-case = smart-case') to ignore case when
   the search string is lower-case only. (GH #320, #579)

Bug fixes:

 - Fix author ident cache being keyed by email only. (GH #424, #526, #547)
 - Fix periodic refresh mode to properly detect ref changes. (GH #430, #591)
 - Add workaround for detecting failure to start the diff-highlight process.
 - Show diffs in the stash view when `set mailmap = true`. (GH #556)
 - Fix parsing of git-log revision arguments, such as `--exclude=...` in
   conjunction with `--all`. (GH #555)
 - Fix diff stat parsing for binary copies.
 - Fix crash when resizing terminal while search is in progress. (GH #515, #550)
 - Fix argument filtering to pass more arguments through to Git.
 - Check for termcap support in split tinfo libs. (GH #568, #585)

tig-2.2.1
---------

Tarballs should now be downloaded from GitHub. Either go to
https://github.com/jonas/tig/releases or use the following pattern:

    https://github.com/jonas/tig/releases/download/tig-VERSION/tig-VERSION.tar.gz

MD5 checksums can be found at:

    https://github.com/jonas/tig/releases/download/tig-VERSION/tig-VERSION.tar.gz.md5

Similarly, the home page is now also on GitHub at https://jonas.github.io/tig/.
A big thanks to Simon L. B. Nielsen for generously hosting Tig on nitro.dk!

Improvements:

 - Support Git's 'diff-highlight' program when `diff-highlight` is set to either
   true or the path of the script to use for post-processing.
 - Add navigation between merge commits. (GH #525)
 - Add 'A' as a binding to apply a stash without dropping it.
 - Bind 'Ctrl-D' and 'Ctrl-U' to half-page movements by default.
 - manual: Mention how to change default Up/Down behavior in diff view.

Bug fixes:

 - Reorganize checking of libraries for termcap functions.
 - Fix `:goto <id>` error message.

tig-2.2
-------

Incompatibilities:

 - Note that all user-defined commands are now executed at the repository root
   instead of whatever subdirectory Tig was started in. (GH #412)
 - Remove `cmdline-args` option to avoid problems where setting it in `~/.tigrc`
   potentially breaks other views due to its "context-sensitive" nature, where
   a `git-log` option maybe cause `git-grep` to fail. (GH #431)

Improvements:

 - Use .mailmap to show canonical name and email addresses, off by default.
   Add `set mailmap = yes` to `~/.tigrc` to enable. (GH #411)
 - Highlight search results, configurable via `search-result` color. (GH #493)
 - Wrap around when searching, configurable via `wrap-search` setting.
 - Populate `%(file)` with file names from diff stat. (GH #404)
 - `tig --merge` implies `--boundary` similar to gitk.
 - Expose repository variables to external commands, e.g. `%(repo:head)` gives the
   branch name of the current HEAD and `%(repo:cdup)` for the repo root path.
 - Add `make uninstall`. (GH #417)
 - Add ZSH completion file (based on Bash completion) (GH #433)
 - Expose the text of the currently selected line as the %(text) (GH #457)
 - Allow users to specify rev arguments to blame (GH #439)
 - Update OSX make config to find brew installed ncurses
 - Add sample git-flow keybinding (GH #421)
 - Add chocolate theme (GH #432)
 - Show stash diffs. (GH #328)
 - Make user tigrc location configurable. (GH #479)
 - Compact relative date display mode. (GH #331)
 - Add date column option controlling whether to show local date.
 - Move to parent commit in the main view. (GH #388)
 - Add `:goto <rev>` prompt command to go to a `git-rev-parse`d revision, e.g.
   `:goto some/branch` or `:goto %(commit)^2`.
 - Respect the XDG standard for configuration files. (GH #513)
 - Show tracking information in `tig status` (GH #504)
 - Resolve diff paths when `diff.noprefix` is true. (GH #487, #488)
 - Support for custom `strftime(3)` date formats, e.g.:

	set main-view-date = custom
	set main-view-date-format = "%Y-%m-%d"

Bug fixes:

 - Prevent staged rename from displaying unstaged changes (GH #472, #491)
 - Fix corrupt chunk header during staging of single lines. (GH #410)
 - Fix out of bounds read in graph-v2 module. (GH #402)
 - Add currently checked out branch to `%(branch)`. (GH #416)
 - Size diff stats correctly for split views.
 - Fix `git-worktree` support by using `git-show-ref`. (GH #437)
 - Add currently checked out branch to `%(branch)` (GH #416)
 - Fix segfault when hitting return in empty file search (GH #464)
 - Remove separator on horizontal split when switching from vertical split
 - Do not expand `--all` when parsing `%(revargs)` (GH #442, #462)
 - Fix exit when the main view is reloaded due to option toggling. (GH #470)
 - Expand all whitespace and control characters to spaces. (GH #485)
 - Restore ability to unbind a default keybinding with `none`. (GH #483)
 - Fix blob view to honor the `wrap-lines` setting.

tig-2.1.1
---------

Improvements:

 - Add support for key combos. (GH #67)
 - See `contrib/vim.tigrc` for Vim-like keybindings. (GH #273, #351)
 - Add GitHub inspired file finder to search for and open any file. (GH #342)
 - Add `search` keymap for navigating file finder search results.

Bug fixes:

 - Fix display of multiple references per commit. (GH #390, #391)
 - Sync the prompt's cursor position with readline's internal position. (GH #396)
 - Keep unstaged changes view open after an staging command. (GH #399)

tig-2.1
-------

Improvements:

 - Improve C99 compliance so Tig compiles with the native compilers on
   Solaris (SunStudio cc) and AIX (xlc). (GH #380)
 - Add move-half-page-up and move-half-page-down actions. (GH #323)
 - Preserve the cursor position when changing the diff context.
 - Show 'Unstaged changes' above 'Staged changes' in the main view. (GH #383)
 - Add `:exec <flags><args...>` prompt command to execute commands.
 - Add shorthand for changing the view settings of a single column,
   eg. `set main-view-author = short`. (GH #318)
 - Show better diff context info in the stage view.
 - Add `%(lineno)` state variable. (GH #304)
 - Use hash table to speed up refs lookup. (GH #350)
 - Show the file path in the blob view when available.
 - Use `set commit-order = default` to use Git's default commit order, even when
   the commit graph is enabled. The option will turn off automatic enabling of
   `--topo-order` when the graph is shown in the main view. (GH #310, #324)
 - Speed up the diff view in large repos by loading git-describe info after the
   diff content has been read. (GH #324)
 - Add the old graph rendering as an option. (GH #310, #324)
 - Add `main-options` setting for specifying default main view options.
   Example: `set main-options = --max-count=1000`. (GH #368)
 - See `contrib/large-repo.tigrc` for settings that will help to speed up Tig in
   large repos. (GH #368)
 - Add `:save-options <file>` prompt command to save config to file. (GH #315)

Bug fixes:

 - Update manual to reflect default keybinding changes. (GH #325)
 - Fix graph support for `--first-parent`. (GH #326)
 - Fix off-by-one error when opening editor from the grep view.
 - Fix status on-branch information.
 - Fix main view to handle the case when git-log doesn't find any commits.
 - Fix corner case when parsing diff chunk when lines information is missing.
 - Ensure main view changes commits are shown right before the current HEAD.
 - Fix rendering of boundary commits.
 - Fix compilation with GNU Make 3.80 by removing `$(abspath)`. (GH #362)
 - Fix config parsing to support shell-like quoting in user-defined command,
   e.g. `bind generic <Ctrl-f> :!git log -G"%(prompt Prompt: )"` (GH #371)
 - Make diff meta information colors more consistent with Git. (GH #375)
 - Fix segfault when updating changes in a maximized stage view opened via the
   main view. (GH #376)
 - Handle line number configs where the interval is not specified. (GH #378)
 - Fix display of error messages during startup. (GH #385)
 - Show untracked files outside the current directory like git-status. (GH #230)

tig-2.0.3
---------

Improvements:

 - Add `:save-display <file>` prompt command to save the current display.
 - Add `:script <file>` prompt command for scripting the Tig UI.
 - Add test framework and convert existing tests to use it.
 - Add command-line option for starting in refs view: `tig refs`. (GH #309)
 - Make blame commit ID colors stable across reloads. (GH #303)
 - Increase blame ID and graph rendering color palette to 14 colors.
 - New setting 'split-view-width' controls the width for vertical splits. It
   takes the width of the right-most view either as a number or a percentage.
 - Expose settings holding command line argument lists: `file-args`, `rev-args`,
   and `cmdline-args`. They are mainly intended for testing purposes but also
   allows to change the filtering arguments dynamically. (GH #306)
 - Add `log-options` setting for specifying default log view options.
   Example: `set log-options = --pretty=fuller`.
 - Use option specific view flags to reload view after `:set` commands.

Bug fixes:

 - Refresh the current view when returning from an external command and
   `refresh-mode=after-command`. (GH #289)
 - Fix readline completion.
 - Fix '/' to `find-next` when readline support is enabled. (GH #302)
 - Fix readline prompt to correctly handle UTF-8 characters.
 - Add warnings for more obsolete actions and colors.
 - Fix passing of commit IDS via stdin to the main view.
 - Fix commit title overflow drawing for multibyte text. (GH #307)
 - Fix installation directory permissions.
 - Handle binary files matches reported by git-grep.
 - Toggling of "args"-typed options without any arguments will clear the current
   arguments. Example: `:toggle blame-options`.
 - Detect custom `pretty.format` settings that break the log view and fallback
   to use the `medium` format. (GH #225)
 - Fix invocation of git-diff for the blame view's line tracking. (GH #316)
 - Fix blame completion of directory names. (GH #317)
 - Fix display of conflicts in the main view when 'show-changes' is enabled.
 - Fix off-by-one error when displaying line numbers in the grep view.
 - When showing the commit graph ensure that either topo, date or author-date
   commit order is used. (Debian #757692) (GH #238)

tig-2.0.2
---------

Improvements:

 - Use git-status for diffing the index.
 - Group toggle options together in the help view.

Bug fixes:

 - Fix refs, main and grep loading when 'gui.encoding' is set. (GH #287)
 - Ignore 'gui.encoding' and 'i18n.commitencoding' when set to 'UTF-8'.
 - Add work-around for missing strndup() on Mac OS X v10.6. (GH #286)
 - Fix spurious abbreviation of author names. (GH #288)
 - Don't show empty action groups in the help view.

tig-2.0.1
---------

Bug fixes:

 - Fix compilation in watch.c.
 - Fix parsing of key bindings mapped to '^' and '<'. (GH #280, #282)

tig-2.0
-------

Note to packagers:

 - Add `.adoc` extension to AsciiDoc files so they show correctly on GitHub.
   This includes `README`, `INSTALL`, and `NEWS` and files in `doc/` directory.
 - `BUGS` file has been merged into `README.adoc`.
 - Default keybindings have been moved to a system-level `tigrc` file, which is
   installed to ${sysconfdir} by default. The content of the `tigrc` file is
   included inside the binary as a fall-back. Pass `NO_BUILTIN_TIGRC=y` to not
   include the system `tigrc` content and reduce the size of the binary.
 - The example `contrib/tigrc` file (made obsolete by `tigrc`) has been removed.
 - Source files have been moved to `src` and `include` and `tig.c` was split up.
 - Build output is less verbose by default; use `make V=1` for old output.

Incompatibilities:

 - In preparation for key combo support, key mappings for symbolic keys (e.g.
   `Up` and `Down`) must now start with `<` and end with `>`, e.g. `<Up>` and
   `<Down>`. Furthermore, escape key combos must now use `<Esc>key` instead of
   `^[key`, and control key mappings must now use `<Ctrl-key>` instead of
   `^key`.
 - Only use 'diff-options' for the diff view and introduce '%(cmdlineargs)' to
   hold non-file and non-revision flags passed on the command line. Affects all
   user-defined commands that expect '%(diffargs)' to hold both 'diff-options'
   arguments and those passed on the command line. (GH #228)
 - Remove built-in keybinding for `git gc`. Add the following line to `~/.tigrc`
   to restore it: `bind generic G ?git gc`.
 - To support view specific colors, '.' can no longer be used interchangeably
   with '-' and '_' in settings names and in particular color names.
 - Replace 'stage-next' action with prompt command using a predefined search
   (see below) and add binding (`@` by default) to also work in the diff view.
 - Most view display options must now be set via the new `*-view` options in
   tigrc. Existing options are no longer recognized, but a warning is shown.
 - Remap default bindings to have more consistent convention: use lower-case
   keys primarily for view switching and non-destructive actions, use upper-case
   keys for view-specific actions including user-defined commands. To preserve
   old default key bindings see `contrib/bindings-v1.x.tigrc`. (GH #257)

Improvements:

 - Add mouse support: scroll view, click line to move cursor, double click line
   (or click again) to "Enter" cursor line, e.g. open commit diff. Disabled by
   default, since it makes text selection less intuitive. If you enable this
   remember to hold down Shift (or Option on Mac) when selecting text.
 - Rewrite and improve the rendering of the commit graph. (GH #144, #46)
 - Add completion and history support to the prompt via readline. (GH #185)
 - Options can be configured and toggled individually for each view. Use the new
   view settings to configure the order and display options for each view
   columns. See system tigrc and tigrc(5) for examples. (GH #89, #222)
 - Add grep view as a front-end to git-grep(1): `tig grep -p strchr`. From
   within Tig, the key for switching or grepping is bound to 'g' by default.
 - Rename 'branch' view to 'refs' view and show tags. (GH #134)
 - Add main view pager mode that reads git-log's '--pretty=raw' data
   from stdin, e.g. `git reflog --pretty=raw | tig --pretty=raw`.
 - Add support for `--graph` and highlight diff stats in the log view.
 - Add default command bindings: `!` to delete branch, `!` to drop stash.
 - Add 'stage-split-chunk' action for splitting chunks in the stage view.
   Bound to '\' by default. (GH #107)
 - Add 'back' action bound to '<' by default, which will return the blame view
   to the previous revision and line after moving e.g. to the parent. (GH #124)
 - Auto-refresh views based on watched repository changes. Configure by setting
   `refresh-mode` to 'manual', 'auto', 'after-command', or 'periodic'. (GH #190)
 - All default settings are in well-documented system `tigrc`.
 - Add `:toggle` prompt command to manipulate options using keybindings. For
   example: `bind diff D :toggle diff-options --patience --notes`. (GH #69)
 - Add a new "auto" value for the 'vertical-split' option to let Tig choose the
   split orientation (this is the new default behavior). Can be toggled.
 - Make it possible to toggle the display of files in untracked directories.
 - Allow Tig to be started with no default configuration by specifying an
   alternative system `tigrc` file, e.g.: `TIGRC_SYSTEM=~/.tigrc.safe tig`. Set
   `TIGRC_SYSTEM` to the empty string to use built-in configuration instead of
 - Key mappings can contain UTF-8 multibyte unicode keys.
 - Warn about conflicting keybindings using Ctrl, e.g. `<Ctrl-f>` and
   `<Ctrl-F>`. (GH #218)
 - Extend key bindings for prompt commands (ie. `bind <keymap> <key> :<prompt>`)
   to support predefined searches, eg.: `bind stage 2 :?^@@`.
 - Git color mappings can be configured in tigrc.
 - More informative configuration error messages.
 - Make reference label formatting configurable, for example:
   `set reference-format = (branch) <tags> remote`. (GH #201)
 - Adjust author width and other view columns automatically. (GH #49)
 - Support view specific colors: `color stage.diff-add yellow default`.
 - Copy `-S`, `-G` and `--grep=` pattern to search buffer so 'find-next' and
   'find-prev' work as expected.
 - Optionally specify custom prompt for `%(prompt)` in shell commands, e.g.
   `bind main B ?git checkout -b "%(prompt Enter new branch name: )"`.
 - Add `%(remote)` and `%(tag)` symbols to complement `%(branch)`.
 - User-defined commands can now be prefixed with any of the supported flags,
   e.g. `?git checkout -b %(branch)`.
 - Open editor at line number for combined diffs e.g. diffs of unmerged files.
 - Add build configuration for Cygwin (OS name: CYGWIN_NT-6.1). (GH #92)
 - Document the Git commands supported by the pager mode.  (GH #1)
   system `tigrc` configuration. (GH #235)

Bug fixes:

 - Fix stash diff display when reloading the stash view after a deleting.
 - Set the commit reference when opening the blame view from the blob view.
 - Correctly identify and highlight the remote branch tracked by HEAD.
 - Pass --no-color after user defined arguments to ensure that colors do not
   break the output parsing. (GH #191)
 - Close stdin when pager mode is not supported.
 - Show newly created branches in the main view. (GH #196)
 - File with 0 changes breaks diffstat highlighting (GH #215)
 - Update %(branch) variable in the main view. (GH #223)
 - Disable graph rendering when either of `--reverse`, `-S`, `-G`, and `--grep`
   are passed to the main view. (GH #127)
 - Only refresh views that support it.
 - Fix author and date annotation of renamed entries in the tree view.
 - Fix use of unsafe methods in the signal handler. (GH #245)
 - Fix rendering in non-UTF8 terminals.
 - Fix stage-update-line by rewriting the diff chunk containing the line instead
   of using `--unidiff-zero` and a diff context of zero. (GH #130)
 - Fix status-update to work for untracked directories. (GH #236)
 - Don't pass log parameters given on the command line to the diff view.

tig-1.2.1
---------

Incompatibilities:

 - Move manual and man pages to doc/ directory and rename AsciiDoc files
   to have .asciidoc as the extension to make them render on GitHub.

Improvements:

 - Show blob sizes in the tree view either as bytes or using binary unit
   prefixes. Example: `set show-file-size = units`. (GH #163)
 - Reduce main view memory usage and startup time, especially when revision
   graph rendering is disabled. (GH #160)

Bug fixes:

 - Fix submodule-related setup to check for non-zero return value from
   setenv(). (GH #188)

tig-1.2
-------

 - Tig now has its own tag on Stack Overflow, where users are invited to
   ask questions: https://stackoverflow.com/questions/tagged/tig

Improvements:

 - Prompt commands can be bound to keys. For example:
   `bind diff F :set diff-options = --full-diff`. (GH #69, #116)
 - Add a diff-options setting for specifying default diff options.
   Example: `set diff-options = --patience`. (GH #116)
 - Options in diff-options and blame-options matching Tig browsing state
   variables are replaced.
 - Show diff stats as wide as the terminal. (GH #109)
 - Show line numbers in the branch view. (GH #135)
 - Add toggles for showing author email or email user names. (GH #115)
 - Open editor at the selected line by prefixing the file argument with
   `+<lineno>`. Tested in vi, Vim, Emacs, Nano, Gedit, Geany. Disable
   by adding `set editor-line-number = no` to ~/.tigrc. (GH #118, #119)
 - Add toggle-files to control whether to show full commit diff or only
   the diff concerning the currently selected file, e.g. for blame.
 - Optionally highlight exceeding characters in long commit titles.
   The default title max width is 50 characters. Customize using:
   `set title-overflow = 50` (GH #125)
 - Add +ESC key bindings. Example: `bind generic ^[v move-page-up` (GH #120)
 - Create temporary files in TMPDIR, TEMP, or TMP before defaulting to /tmp.
 - Reenable `tig log` as a subcommand. (GH #146)
 - Enable tilde expansion in ~/.tigrc "source" commands. (GH #168)
 - Introduce the stash view, bound to the 'y' keybinding. (GH #169, #174)

Bug fixes:

 - Fix blame and status to work in directories starting with a dot. (GH #172)
 - Reload current branch name when reloading the status view. (GH #93)
 - Fix compile errors on old Solaris. (GH #97)
 - Reload HEAD info when reloading the stage view. (GH #104, #93)
 - Fix disappearing branch labels after external commands. (GH #148)
 - Fix diff view display for staged/unstaged changes when using 'd'.
 - Fix display of status messages when toggling view options. (GH #111)
 - Fix illegal memory access. (GH #98)
 - Fix display of all branches label in repos with short branch names.
 - Fix rendering glitch for branch names.
 - Do not apply diff styling to untracked files in the stage view. (GH #153)
 - Fix tree indentation for entries containing combining characters. (GH #170)
 - Ignore unrepresentable characters when transliterating text for rendering.
 - Transliterate text to output encoding before trimming it to avoid
   misalignment. (GH #86)
 - Introduce a more natural context-sensitive log display. (GH #155)

tig-1.1
-------

Incompatibilities:

 - Disable diff move/copy detection by default, boosting diff
   performance on larger projects. Use git config 'diff.renames' option
   (Git-wide) to set your preferred behavior. Environment variable
   TIG_DIFF_OPTS can be used to restore the old behavior.
 - Fix manual keybinding for stage-single-line. (GH #108)
 - Values set for author-width and filename-width will result in widths
   one character bigger than previously.

Improvements:

 - Typing a text in the prompt will be interpreted as a Tig command.
   Prefixing the command with a '!' will execute this system command in
   an external pager. Entering a single key will execute the
   corresponding key binding.
 - Basic support for wrapping long line in pager, diff, and stage views.
   Enable using: `set wrap-lines = yes`. (GH #2)
 - User-defined commands prefixed with a '?' means prompt before
   execution. Example: `bind main B !?git rebase -i %(commit)`.
 - User-defined commands prefixed with a '<' means exit after execution.
   Example: `bind main C !<git commit`. (GH #66)
 - User-defined commands are executed unquoted to support shell commands.
   Example: `bind generic I !@sh -c "echo -n %(commit) | xclip -selection c"`.
   (GH #65)
 - Configure case-insensitive searches using: `set ignore-case = yes`.
 - Add "deleted mode" line type for better diff coloring.
 - Open editor when requesting edit action from within a file diff.
 - Update AX_WITH_CURSES to build under Cygwin.
 - Improve tigrc(5) documentation. (Debian #682766)
 - Allow to build on Mac OS 10.7 without the configure script. (GH #25)
 - Add option to split the view vertically instead of horizontally.
   Example: `set vertical-split = yes'. (GH #76)
 - Add 'show-id' and 'id-width' options to configure the display of
   commit IDs in the main view and ID width in the blame view. (GH #77)
 - Allow to override Git based encoding to UTF-8 by setting
   'i18n.commitencoding' or 'gui.encoding'.
 - Improve autobuild support to track generated files and work with
   autoreconf 2.61.
 - Commit IDs are read from stdin when --stdin is given; works for main
   and diff view, e.g. `tig --no-walk --stdin < cherry-picks.txt`.
 - Add option to disable focusing of the child view when it's opened.
   Disable using: `set focus-child = no`. (GH #83)
 - Allow to open blob related with added content in a diff. (GH #91)

Bug fixes:

 - Fix commit graph regression when a path spec is specified. (GH #53)
 - Main view: only show staged/unstaged changes for the current branch.
 - Support submodules created with current version of git. (GH #54)
 - Fix diff status message for file diffs with no content changes.
 - Fix parent blaming when Tig is launched in subdirectory. (GH #70)
 - Do not show deleted branch when reloading the branch view.

tig-1.0
-------

The master repository is git://github.com/jonas/tig.git, and the old
master repository (http://jonas.nitro.dk/tig/tig.git) will be retired.

Improvements:

 - Use git-log(1)s default commit ordering. The old behavior can be
   restored by adding `set commit-order = topo` to ~/.tigrc.
 - Support staging of single lines. Bound to '1' default. (GH #21)
 - Use +<lineno> to open the initial view at an arbitrary line. (GH #20)
 - Add show-notes ~/.tigrc option. Notes are displayed by default.
 - Support jumping to specific SHAs in the main view.
 - Decorate replaced commits.
 - Display line numbers in main view.
 - Colorize binary diff stats. (GH #17)
 - Custom colorization of lines matching a string prefix (GH #16).
   Example configuration: color "Reported-by:" green default
 - Use Git's color settings for the main, status and diff views.
   Put `set read-git-colors = no` in ~/.tigrc to disable.
 - Handle editor options with multiple arguments. (GH #12)
 - Show filename when running tig blame with copy detection. (GH #19)
 - Use 'source <path>' command to load additional files from ~/.tigrc
 - User-defined commands prefixed with '@' are run with no console
   output, e.g.

   	bind generic 3 !@rm sys$command

 - Make display of space changes togglable in the diff and stage view.
   Bound to 'W' by default.
 - Use per-file encoding specified in gitattributes(5) for blobs and
   unstaged files.
 - Obsolete commit-encoding option and pass --encoding=UTF-8 to revision
   commands.
 - Main view: show uncommitted changes as staged/unstaged commits.
   Can be disabled by putting `set show-changes = no` in ~/.tigrc.
 - Add %(prompt) external command variable, which will prompt for the
   argument value.
 - Log information about Git commands when the TIG_TRACE environment
   variable is set. Example: `TIG_TRACE=/tmp/tig.log tig`
 - Branch view: Show the title of the last commit.
 - Increase the author auto-abbreviation threshold to 10. (GH #49)
 - For old commits show number of years in relative dates. (GH #50)

Bug fixes:

 - Fix navigation behavior when going from branch to main view. (GH #38)
 - Fix segfault when sorting the tree view by author name.
 - Fix diff stat navigation for unmodified files with stat changes.
 - Show branches/refs which names are a substring of the current branch.
 - Stage view: fix off-by-one error when jumping to a file in a diff
   with only one file.
 - Fix diff-header colorization. (GH #15)

tig-0.18
--------

Incompatibilities:

 - Remove support for the deprecated TIG_{MAIN,DIFF,LOG,TREE,BLOB}_CMD
   environment variables.

Improvements:

 - Pressing enter on diff stat file lines will jump to file's diff.
 - Naïvely color blame IDs to distinguish lines.
 - Document palette color options used for revision graph and blame IDs.
 - Add support for blaming diff lines.
 - Add diff-context option and bindings to increase the diff context in
   the diff and stage view.
 - (GH-6) Make blame configurable via extra options passed from the command
   line and blame-options setting from ~/.tigrc. For example:

   	set blame-options = -C -C -C

Bug fixes:

 - Expand browsing state variables for prompt. (LP #694780, Debian #635546)
 - Fix segfault when sorting the branch view by author.
 - Expand %(directory) to . for the root directory. (GH-3)
 - Accept 'utf-8' for the line-graphics option as indicated in the docs.
 - Use erasechar() to check for the correct backspace character.

tig-0.17
--------

Improvements:

 - Start rewrite of the revision graph renderer. Three modes are
   supported UTF-8, ncurses line graphics, and ASCII. Also, enable
   revision graph rendering by default.

Bug fixes:

 - Fix ncurses 5.8 issue by passing non-zero column size to newwin().
 - Fix opening of diffs when browsing branches.

tig-0.16.2
----------

Bug fixes:

 - Fix regression causing empty tree view.
 - Fix set_tabsize() compile error for older versions of ncurses.

tig-0.16.1
----------

Improvements:

 - Add scroll-first-col action to jump to the first column. Bound to '|'
   by default.
 - Add 'status-untracked-dirs' option to ignore unknown directories
   contents in the status view. On by default.

Bug fixes:

 - Fix 'tig show <commit>' to show the provided commit.
 - Fix problem with empty diff views when file specs were passed on the
   command line.
 - Fix segfault when starting Tig in pager mode.

tig-0.16
--------

Incompatibilities:

 - Encode everything internally as UTF-8. This can affect performance,
   but should in general improve handling of character lengths etc.
   Also, to properly handle UTF-8 environments use ncurses with wide
   character support.
 - The use of TIG_{MAIN,DIFF,LOG,TREE,BLOB}_CMD environment variables
   has been deprecated. To allow configuration of the diff view,
   TIG_DIFF_OPTS can be used.

Improvements:

 - Plug several memory leaks.
 - Command line arguments are split into diff, revision, and file
   arguments and made available as %(diffargs), %(revargs), and
   %(fileargs). Diff view will limit diffs using %(fileargs).
 - Status view: update the file variable when a line is selected so
   %(file) works as expected.
 - Branch view: add %(branch) symbol providing access to the selected
   branch.
 - Branch view: add entry to browse all branches (uses git-log's --all
   flag).
 - Abbreviation of author names can now be configured and toggled.
 - Mark detached heads with [HEAD].
 - Add support for displaying dates in local time.

Bug fixes:

 - Status view: fix usage from sub directories, which was broken by the
   changes made to support blame view from sub directories.
 - Fix text expansion to not truncate long lines
 - Fix parsing of boolean show-date values.
 - Fix relative date.
 - Fix unbind to behave as if the keybinding was never defined.
 - Fix unbind to also cover built-in run requests.
 - Fix parsing of unknown keymap names.
 - Blame view: fix parent blame to detect renames. It uses "previous"
   line info from the blame porcelain output added in Git version 1.6.3.

tig-0.15
--------

Incompatibilities:

 - Setting the cursor color no longer automatically sets the text to
   bold. The old 'lazy' behavior was a bug.
 - Remove check for git-repo-config, which was officially deprecated in
   Git version 1.5.4. The configure script no longer depends on Git
   being installed.

Improvements:

 - Provide the manual as a man page named tigmanual(7).
 - Add ability to toggle between showing shorter dates (without time
   info) and relative dates. Use 'D' to toggle between date formats.
 - Show the active (instead of the default) keybindings in the help
   view. Furthermore, honor the keymap when suggesting actions in the
   help messages.
 - Add branch view for choosing which branch to display in the main
   view. Bound to 'H' by default.
 - Tree view: show entry to parent directory ('..') when running from
   subdirectory.
 - Tree view: sort entries by name, date or author. Toggling is bound to
   'i' by default, with 'I' controlling whether or not to sort in
   ascending order.
 - Make height of the lower view in a split view configurable by setting
   the 'split-view-height' variable to a number or a percentage.
   Defaults to 2/3 of the total view height.
 - Allow multiple text attributes for color commands:

	color cursor white blue underline bold

Bug fixes:

 - Blame view: fix loading of blame data when opened from the tree view
   and CWD is not the repo root. (Debian bug 540766)
 - Tree view: fix searching.

tig-0.14.1
----------

Improvements:

 - Status view: improve "on branch" information inspired by the prompt
   code in Git's bash completion script.
 - Colors for 256-capable terminals can be specified as colorN.
 - Entering a number in the prompt will jump to that line number.
 - Handle core.worktree by setting GIT_DIR and GIT_WORK_TREE.
 - Make behavior of horizontal scrolling configurable by setting the
   'horizontal-scroll' variable to a number or a percentage. Defaults to
   scrolling 50% of the view width.

Bug fixes:

 - Status view: show error when failing to open a file.
 - Status view: report failures to update a file.
 - Blame view: fix problem with uninitialized variable.
 - Blame view: use line number information when loading blame for
   specific commit.
 - Fix handling of quoted strings in the config file.
 - Fix horizontal scrolling glitches.

tig-0.14
--------

Incompatibilities:

 - The screen-resize action has been deprecated. It had no real use for
   users and was never meant to be exposed.
 - The "tree-parent" action was renamed to "parent". Warnings will be
   emitted for transition.
 - Remove parsing of deprecated option -S and subcommands log and diff.
 - The "author" color replaces "main-author". Setting the latter will
   now set the "author" color.

Improvements:

 - Horizontal scrolling. Bound to Left/Right by default.
 - Read tigrc(5) options from Git configuration files using the syntax:

	[tig] show-rev-graph = true
	[tig "color"] cursor = yellow red bold
	[tig "bind"] generic = P parent

 - Tree view: avoid flickering when updating.
 - Tree view: annotate entries with commit information.
 - Tree & blob view: open any blob in an editor.
 - Stage & main view: restore view position when reloading.
 - Blame view: load blame for parent commit. For merge commits the parent
   is queried. Bound to ',' by default via the existing "parent" action.
 - Abbreviate author names to initials when the width of the author column
   is below 6 characters.

Bug fixes:

 - Tree view: fix memory corruption bug when updating.
 - Tree view: improve handling of empty trees.
 - Status view: fix reverting of unmerged files.
 - Fix regression for non-UTF-8 locales corrupting the view data.
 - Fix regression parsing multiple spaces in ~/.tigrc.

tig-0.13
--------

Incompatibilities:

 - Commands from the environment (e.g. TIG_MAIN_CMD) will no longer have
   access to shell features, such as subshells and variable expansion.
   The easiest way to upgrade your configuration is to put such commands
   in a script file or as a Git alias.

Improvements:

 - Display repository references in the sorted order: tags, heads,
   tracked remotes, remotes.
 - Add bash completion for blame.
 - Tree view: edit files of the current branch.
 - Run requests: new identifiers %(directory), %(file), and %(ref)
 - Improve responsiveness and view loading speed by using select(2).

Bug fixes:

 - Separate blame revision and file argument by "--" to avoid problems.
 - Main view: fix redrawing of the last commit wrt. the revision graph.
 - Fix waiting for input after executing a run request in pager mode.
 - Status & stage view: refuse to open directories and deleted files.
 - Tree view: show error when requesting blame for all non-file entries.
 - Do not draw loading views, which are not displayed.
 - Fix launching of mergetool from a subdirectory.

tig-0.12.1
----------

Improvements:

 - Status view: revert uncommitted diff chunks and unstaged files with
   changes. Bound to '!' by default.
 - Main view: use --topo-order also when rev-list arguments are given on
   the command line.
 - Log view: support for refreshing.

Bug fixes:

 - Status view: use ls-files' --exclude-standard so user specific ignore
   rules are effective. The option was added in Git version 1.5.4.
 - Stage view: fix assertion failure triggered when updating while
   status view is not displayed.
 - Help view: avoid confusion by showing "(no key)" instead of "'?'" for
   unbound requests.
 - Reload repository references when refreshing the main (and log) view.
 - Do not maximize views when refreshing.

tig-0.12
--------

Improvements:

 - F5 also refreshes the current view.
 - Allow line graphics to be disabled with new line-graphics option.
 - Main view: also include the reference names when searching.
 - Main view: support for refreshing.
 - Main view: disable boundary commits by default. Use --boundary when
   they should be shown. (Debian bug 498628)
 - Stage view: add stage-next action to jump to next diff chunk that can
   be staged. By default bound to '@'.
 - Configure: check for the ncurses header files.
 - Add author-width option to customize the width of the author column.
   For example, put the following in ~/.tigrc: set author-width = 10

Bug fixes:

 - Fix regression when staging all diff chunks in a section.
 - Bind the maximize view action to 'O'; it conflicted with the
   keybinding to launch the merge tool in the status view.
 - Fix problem with $(cmd) usage in shell code. Some shells (jsh)
   installed as /bin/sh does not support it.
 - Do not show incomplete boundary commits when --no-walk is used.
 - Documentation: Rename gitlink macro to support AsciiDoc 8.2.3.
 - Ignore pipe reads with errno "Success" reported after a signals,
   for example when refreshing doing background loading.

tig-0.11
--------

Incompatibilities:

 - Remove parsing of deprecated options: -g, -l, -d.
 - The first seen '--' will stop option parsing and is passed to Git
   instead of breaking out of Tig's option parsing.

New features:

 - Blame view; bound to 'B' by default, reachable from the command line
   and the tree, status, and stage views.
 - Blame/main view: allow display of date, author, and references to be
   toggled on/off. Bound to 'D', 'A', and 'F' respectively.
 - Add action to maximize the current view.

Improvements:

 - Show the current branch in the status view.
 - Show local/light-weight tags.

Bug fixes:

 - Fix regressions for the pager mode.
 - Fix refreshing of the index with working directory info.

tig-0.10.1
----------

Improvements:

 - Status view: detect renamed files and show them with 'R'.
 - Status view: refresh the index to avoid "empty diffs".
 - Diff view: make diff headers more verbose to include e.g. committer.
 - Configure: check for the ncursesw library.

Bug fixes:

 - Fix UTF-8 handling for tag names and commit messages.
 - Fix the check for git-config(1) in configure to handle the case when
   Git has been installed using a libexecdir which is not in the path.
 - Fix replacing of SYSCONFDIR when installing from released tarballs.

tig-0.10
---------

Incompatibilities:

 - Deprecate most Tig specific command line options to make Tig more
   compatible with gitk. The deprecated options are: -g, -l, -d, and -S.
   Use of any of them will result in a warning being printed to stderr.
   Instead of '-S', use the new 'status' subcommand.
 - Make man page building depend on DocBook XSL version >= 1.72.0.
 - Install man pages in $(prefix)/share/man.
 - Implement the cherry pick action (bound to 'C') using new support for
   running external commands. This obsoletes the TIG_CHEERY_PICK
   environment variable

New features:

 - Add support for binding keys to external commands. To bind '.' to
   running git-commit(1), add the line: "bind generic . !git commit" to
   your ~/.tigrc. Each command can have replacement string such as
   %(commit), %(head), and %(blob), which are substituted before the
   command is run.
 - Add system-wide configuration file defaulting to $(prefix)/etc/tigrc.
 - Add the environment variables TIGRC_USER and TIGRC_SYSTEM to change
   user and system-wide configuration files, respectively.

Improvements:

 - Main view: color the revision graph.
 - Main view: show boundary commits; they are marked with '^' in the
   revision graph.
 - Tree view: add tree-parent action to jump to view of the parent tree.
   Bound to ',' by default.
 - Allow the default terminal colors to be overwritten. To use black
   text on white, add the line "color default white black" to your
   ~/.tigrc.
 - Misc. documentation improvements.

Bug fixes:

 - Use git-diff-index(1) and git-diff-files(1) instead of git-diff(1) to
   avoid running external diff drivers.
 - Use --no-color when calling git-log(1).
 - Fix crash when opening mergetool for lines that are not unmerged.

tig-0.9.1
---------

Incompatibilities:

 - Make the clean rule to never remove generated documentation files.
   Use the distclean rule for accomplishing this.

New features:

 - Add support for cherry-picking commits in the main view to the
   current branch. Bound to 'C' by default.

Improvements:

 - Add support for launching git-mergetool(1) from the status view.
   Bound to 'M' by default.
 - Add support for refreshing/reloading the status view
 - Detect working trees and disable the status view when it is missing.

Bug fixes:

 - Fix iconv() checking in configure.
 - Fix editor invocation to make paths relative to the project root.
 - Fix out-of-range current line when reloading the status view.
 - Include autoconf files in the tarball generated by `make dist`.

tig-0.9
-------

New features:

 - Add bash completion script for Tig (contrib/tig-completion.bash).
 - Add optional autoconf-based build infrastructure.
 - Add stage view for showing changes in the working tree and add
   support for staging individual diff chunks for commit.

Improvements:

 - Status view: allow all files in a section to be staged for commit.
 - Status view: Add support for opening files in an editor. Bound to 'e'
   by default.
 - Tree view: use a stack for remembering the lines for parent tree.

/* vim: set tw=80: */
